;            ͻ
;                  LDEBUG.ASM       
;                                                               
;                              Loader Debugger                  
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code Starts .................. 06/04/1996       
;               Last Update .................. 04/08/1996       
;            ͼ
; ! It's only used by me when I'm writing a new loader.
;   I included it if you want to add a driver. (SEND IT TO ME !)

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32

INCLUDE LDEBUG.INC
INCLUDE UTILS.INC
INCLUDE MACROS.INC
INCLUDE USM.INC
INCLUDE USSVAR.INC

;͸
;  Print_Header: Display the USM Header                                   
;                                                                         
; Input: ESI, Header location                                             
;                                                                         
;
Print_Header Proc
	writeln 'Header USM'
	
	writeln 'MName: '
	;MName
	
	write 'MFlags: ' 
	xor eax,eax
	mov ax,MFlags[ESI] 
	call Print_Hex
	Writeln
	
	write 'MVersion: ' 
	mov ax,MVersion[ESI] 
	call print_Dec
	Writeln
	
	write 'MTracker: '
	mov ax,MTracker[ESI] 
	call print_Dec
	Writeln
	
	write 'MChannel: '
	mov ax,MChannels[ESI] 
	call print_Dec
	Writeln
	
	write 'MSongLen: '
	mov ax,MSongLen[ESI]
	call Print_Dec
	Writeln
	
	write 'MPattern: '
	mov ax,MPatterns[ESI]
	call Print_Dec
	Writeln
	
	write 'MRestart: '
	mov ax,MRestart[ESI]
	call Print_dec
	Writeln
	
	write 'MInstruments: '
	mov ax,MInstruments[ESI]
	call Print_dec
	Writeln
	
	write 'MTempo: '	
	mov al,MTempo[ESI]	
	call print_dec
	Writeln
	
	write 'MBPM: '	
	mov al,MBPM[ESI]	
	call print_dec
	Writeln

	write 'MOrder: '  
	mov eax,0
	mov cx,0
PrintOrderLoop:
	mov al,MOrder[ESI+ECX]
	call print_dec
	Write ','
	inc cx
	cmp MSongLen[ESI],cx
	jne PrintOrderLoop

	ret
Print_Header Endp


;͸
;  Print_Instruments: Display the USM Instruments                         
;                                                                         
; Input: ESI, Header location                                             
;                                                                         
;
NbPrinted DD 0

Print_Instruments Proc
	mov NbPrinted,0
	add esi,MInstrPtr

_Print_Instruments_Loop:
	push esi
	mov esi,[esi]
	cmp esi,0
	je _NoInstr

	write 'InstrPtr: '
	mov eax,esi	
	call print_hex	
	
	push esi
	Write ' Iname: '
	add esi,IName
	mov ecx,32
	call Print_Str	
	pop esi
	
	Write ' NbSamples: '
	movzx eax,INbSmp[esi] 
	call print_dec

	Writeln ' '
	
	WaitKey
	
_NoInstr:	
	pop esi
	add esi,4
	inc NbPrinted
	cmp NbPrinted,256
	jne _Print_Instruments_Loop
	ret
Print_Instruments Endp

CODE32 ENDS
;=============================================================================
end
; LDEBUG.ASM (c) 1997 FreddyV/Useless