;            ͻ
;                  MODLOAD.ASM      
;                                                               
;                       Useless MOD Loader (MOD->USM)           
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code starts .................. 19/08/1996       
;               Last update .................. 08/12/1996       
;            ͼ

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32

Yes Equ 0
No  Equ -1

FullLoad Equ Yes	; Yes => Load all (Players,trackers..)
			; No  => Load all needed for the module (Demos,games..)

INCLUDE OS.INC
INCLUDE MODLOAD.INC

INCLUDE MEMORY.INC
INCLUDE LOADUTIL.INC
INCLUDE USS.INC
INCLUDE USM.INC		; Useless Module Structures Definition
INCLUDE USSVAR.INC      ; Instruments and samples definition

INCLUDE UTILS.INC

;=============================================================================

ModIdents Label Dword
          DB 'M.K.','FLT4','M!K!','M&K&','FA04','RASP','4CHN','6CHN','8CHN'
          DB 'FLT8','OCTA','OKTA','CD81','FA08','10CH','12CH','16CH','18CH'
	  DB '20CH','22CH','24CH','26CH','28CH','32CH','TDZ4','TDZ6','TDZ8'
	  DD 0     ; 0 => the table end

MODIdChannels  label byte
          DB 4     ,4     ,4     ,4     ,4     ,4     ,4     ,6     ,8  
	  DB 8     ,8     ,8     ,8     ,8     ,10    ,12    ,16    ,18
	  DB 20    ,22    ,24    ,26    ,28    ,32    ,4     ,6     ,8   

MODH	DD 0
USMH	DD 0

FileId  DD 0
MODChannels DB 0
MODSamples  DB 0
SongLenOffset DD 0

MODOffset DD 0
USMFlags  DW 0

;=============================================================================

;͸
;  MOD_LOAD: Load/convert a MOD file. (MOD->USM)                          
;                                                                         
; Input: ESI file name/path                                               
;                                                                         
; Output: CF Set=> Error                                                  
;         EAX returns the error number                                    
;                                                                         
;         CF Clear                                                        
;         ESI pointer to the USM module                                   
;
MOD_LOAD Proc

	mov MODH,0

	MOpen ESI
	jc MODLoadErr

	; *** Detect MOD Type ***

	MSetPos 1080
	
	mov eax,offset FileId
	Mread eax,4		; Read the file Id (M.K, 8CHN...)

	mov eax,FileId

	mov MODChannels,4
	mov MODSamples,15
	mov SongLenOffset,470
	mov MODOffset,600	
	
	mov edx,0
DetectIdLoop:	
	mov eax,ModIdents[4*edx]
	inc edx
	cmp eax,0
	je  DetectIdEnd
	cmp FileId,eax
	jne DetectIdLoop
	dec edx
	mov al,MODIdChannels[edx]
	mov MODChannels,al
	mov MODSamples,31
	mov SongLenOffset,950
	mov MODOffset,1084
DetectIdEnd:	

	; *** Load the MOD Header (Name+Samples def+Order) ***

	movzx eax,ModSamples
	imul ax,30
	add eax,20+2+128
	mov ecx,eax
	push ecx		
		
	Calloc USMHeaderLen
	jc MODLoadMemErr
	mov USMH,eax

	Malloc ecx
	mov MODH,eax
	jc MODLoadMemErr
	
	MSetPos 0  ; ! Tester MReadPos !

	pop ecx
	
	Mread MODH,ecx		;Read the MOD Header
	jc MODLoadErr
	
	; *** Convert MOD Header -> USM Header ***

	mov esi,MODH
	mov edi,USMH

	mov MTracker[edi],M_MOD

	If FullLoad eq yes
	mov MId[edi],'MLSU'
	mov MLen[edi],USMHeaderLen
			
	mov ecx,20/4
	add edi,MName
	cld
	rep movsd		;Convert the Module Name
	
	mov esi,MODH
	mov edi,USMH
	EndIf

				;Set Panning Table
	push edi
	add edi,MChPan
	mov cx,32/4
	mov eax,80808080h
	rep stosd	
	pop edi
	
	add esi,SongLenOffset
	movzx eax,byte Ptr [esi]	; Song Length
	inc esi
	mov MSongLen[edi],ax	

	movzx ebx,byte Ptr [esi]	; Restart Order
	inc esi
	cmp bx,ax
	jbe RestartOk
	xor ebx,ebx
RestartOk:	
	mov MRestart[edi],bx		
	
	movzx eax,MODChannels
	mov MChannels[edi],ax			
		
	xor ecx,ecx
	xor ebx,ebx
GetPatternNumberLoop:
	mov al,[esi+ecx]
	cmp bl,al
	ja  PatternLower
	mov bl,al
PatternLower:	
        inc ecx
        cmp ecx,128
        jne GetPAtternNumberLoop
        inc bx

        mov MPatterns[edi],bx	
        mov PTotal,bx           ;Save the Number of patterns
	
        movzx eax,MODSamples
        mov MSamples[edi],ax
	
        mov MTempo[edi],6
        mov MBPM[edi],125

	add edi,MOrder
	mov cx,128/4
	cld
	rep movsd	

	MSetPos MODOffset	;Set Filepos to the 1st Pattern
	
	call MOD_LoadPatterns
	
	call MOD_LoadSamples

	clc
	mov esi,USMH		;Returns a pointer to the Module...
	jmp MODLoadEnd	
	
MODLoadMemErr:
        MClose		;Close the file
	call _MEMORY_ERROR
		
MODLoadErr:
	MCLose		;Close the file
	Writeln 'MODLoad Error'

	stop
	
	stc
MODLoadEnd:

	pushf
	MClose		;Close the file
	cmp MODH,0
	je NoMODHFree
	free MODH
NoMODHFree:	
	popf
	
	ret
MOD_LOAD Endp


;͸
;  MOD_Loadpatterns: Load/convert MOD patterns. (MOD->USM)                
;                                                                         
;

PCount DW 0
PTotal DW 0
PPtr   DD 0
PEnd   DD 0

USMPattSize DD 0
MODPattSize DD 0

MODPPtr DD 0

;Warning: PTotal must be >0 

MOD_LoadPatterns Proc Near

	movzx eax,MODChannels
	imul ax,64*4
	mov MODPattSize,eax
	
	movzx eax,MODChannels
	imul ax,64*5
	add eax,USMPatternSize
	mov USMPattSize,eax	

	mov PCount,0
	
_LoadPatternsLoop:
	
	Calloc USMPAttSize		;Allocate USM Pattern Memory
	mov PPtr,eax

	mov edi,USMH
	movzx edx,PCount
	mov MPattPtr[edi+4*edx],eax	;Save the Pattern Offset

	Malloc MODPAttSize		;Allocate the MOD patter data buffer
	mov MODPPtr,eax
	
	mov ecx,MODPattSize
	add MODOffset,ecx
	MRead MODPPtr,ecx	 	;Load the MOD pattern data

	; Convert the pattern MOD->USM
	
	mov esi,MODPPtr	
	mov edi,PPtr
	
	mov ax,PCount
	mov Pnumber[edi],ax
	mov ax,64
	mov Prow[edi],ax

	If FullLoad eq yes
	mov SId[edi],'PLSU'
        mov eax,USMPattSize
	mov Psize[edi],eax
        endif
	
	mov PEnd,edi
	add PEnd,eax

	add edi,USMPatternSize
_PConvertLoop:
	
	mov ax,[esi]
	xchg ah,al
	mov bh,ah
	mov bl,[esi+2]
 	mov cl,bl
	shr cl,4
	and bh,0F0h
	add cl,bh
	mov [edi+1],cl	;sample number
	and bl,0Fh
	mov [edi+3],bl  ;effect number
	mov bl,[esi+3]
	mov [edi+4],bl  ;effect parameter

	and ax,0FFFh    ;Amiga periode
	shl ax,2        ;Internal period is Amiga period*2
	xor edx,edx
	cmp ax,0
	je NoteFound
getNoteNumberLoop:	
	mov bx,Period_Table[2*edx]
	inc edx
	cmp bx,0
	je NoteFound
	cmp bx,ax
	ja getNoteNumberLoop	
	mov cx,Period_table[2*(edx-2)] ; bx > ax > cx
	sub cx,ax
	sub ax,bx
	cmp ax,cx
	jb NoteFound
	dec edx
NoteFound:	
	mov [edi],dl	;Note
	
	add esi,4
	add edi,5
	
	
	cmp byte Ptr [edi-2],14    ; Convert Command Exy to Command 36+x
	jne No_ExtendedCommand
	mov al,[edi-1]
	shr al,4
	add al,36
	mov [edi-2],al
	and byte Ptr [edi-1],0Fh
No_ExtendedCommand:	

	cmp edi,PEnd
	jb  _PconvertLoop

	Free MODPPtr
	
	MSetPos MODOffset		
	
	inc PCount
	mov ax,Ptotal
	cmp PCount,ax
	jne _LoadPatternsLoop	; Pattern Loop

	clc
	ret

MOD_LoadPatterns Endp

;͸
;  MOD_LoadSamples: Load/convert MOD samples. (MOD->USM)                  
;                                                                         
;

SCount	DW 0
MODSOffset DD 0
USMSOffset DD 0

FineTable DW 8363,8413,8463,8529,8581,8651,8723,8757,7895,7941
          DW 7985,8046,8107,8169,8232,8280

MOD_LoadSamples Proc Near
	mov SCount,0
	mov eax,MODH
	add eax,20
	mov MODSOffset,eax
	
_LoadSamplesLoop:

	Calloc USSSampleSize
	mov USMSOffset,eax

	mov esi,USMH
	movzx edx,SCount
	mov MSamplPtr[esi+4*edx],eax	;Save the Sample Offset

	mov edi,USMSOffset	; Get Sample Header Offset

	If FullLoad eq Yes		
	mov SId[edi],'LPMS'
	mov SLen[edi],USSSampleSize
	add edi,SName
	mov esi,MODSOffset
	mov ecx,22/4
	cld
	rep movsd
	mov edi,USMSOffset
	mov esi,MODSOffset
	endif	

	;Convert MOD Sample -> USM Sample
	
	movzx eax,MODSLength[esi]	; Convert Length And Loop
	xchg ah,al
	shl eax,1

	push eax
	MSetPos MODOffset 
	pop eax
	add MODOffset,eax
	
	mov SType[edi],0  ; Mettre boucl ou non !!!!!!!

	mov SLength[edi],eax
	movzx eax,MODSLoop[esi]
	xchg ah,al
	shl eax,1
	mov SLoop[edi],eax
	
	movzx ebx,MODSLoopLen[esi]
	xchg bh,bl
	shl ebx,1
	cmp ebx,2
	jbe NoLoop
	mov SType[edi],SM_Loop  
NoLoop:	

	add eax,ebx
	mov SLoopEnd[edi],eax
	
	mov al,MODSVolume[esi]
	mov SVolume[edi],al
	mov al,80h
	mov SPanning[edi],al

	movzx eax,MODSFine[esi]
	mov bx,8363
	cmp ax,16
	jae WrongFineTune
	mov bx,FineTable[2*eax]
WrongFineTune:	
	mov SFine[edi],bx

	cmp SLength[edi],2
	jbe  NotLoadSample
	call LU_LoadSample     ; Load sample data.
        jmp LoadNextSample
NotLoadSample:
        mov SLength[edi],0
LoadNextSample:        

	; ** Sample load end, load next sample **

	add MODSOffset,30
	
	inc SCount 
	movzx eax,MODSamples
	cmp SCount,ax
	jne _LoadSamplesLoop

	ret
MOD_LoadSamples Endp

CODE32 ENDS
;=============================================================================
end
; MODLOAD.ASM (c) 1997 FreddyV/Useless