;            ͻ
;                  USMLOAD.ASM      
;                                                               
;                             Useless USM Loader                
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code starts .................. 19/10/1996       
;               Last Update .................. 03/01/1997       
;            ͼ

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32

Yes Equ 0
No  Equ -1

FullLoad Equ Yes	; Yes => Load all (Players,trackers..)
			; No  => Load all needed for the module (Demos,games..)

INCLUDE OS.INC
INCLUDE USMLOAD.INC

INCLUDE MEMORY.INC
INCLUDE LOADUTIL.INC
INCLUDE USS.INC
INCLUDE USM.INC		; Useless Module Structures Definition
INCLUDE USSVAR.INC      ; Instruments and samples definition

INCLUDE UTILS.INC

;=============================================================================

USMH	DD 0

;=============================================================================

;͸
;  USM_LOAD: Load an USM file.                                            
;                                                                         
; Input: ESI file name/path                                               
;                                                                         
; Output: CF Set=> Error                                                  
;         EAX returns the error number                                    
;                                                                         
;         CF Clear                                                        
;         ESI pointer to the USM module                                   
;
USM_LOAD Proc
        mov USMH,0

	MOpen ESI
	jc USMLoadErr

	; *** Load the USM Header ***

	Malloc USMHeaderLen
	jc USMLoadMemErr
	mov USMH,eax

	MSetPos 0               ; ! Tester MReadPos !
	Mread USMH,USMHeaderLen	; Read the USM Header
	jc USMLoadErr
	
	call USM_LoadPatterns
	
	call USM_LoadSamples

	clc
	mov esi,USMH    ;Returns a pointer to the Module...
	jmp USMLoadEnd	
	
USMLoadMemErr:
        MClose          ;Close the file
        call _MEMORY_ERROR
		
USMLoadErr:
        MCLose          ;Close the file
        Writeln 'USMLoad Error'

        stop
	
        stc
USMLoadEnd:

        pushf
        MClose          ;Close the file
        popf	
        ret
USM_LOAD Endp


;͸
;  USM_Loadpatterns: Load USM patterns.                                   
;                                                                         
;

LPId     DD 0                    ; Useless pattern Id 'USLP'
LPSize   DD 0
LPnumber DW 0
LProw    DW 0

MODPPtr DD 0

;Warning: PTotal must be >0 

USM_LoadPatterns Proc Near

        mov esi,USMH

        xor ecx,ecx
LoadPatternsLoop:        
        mov edi,MPattPtr[esi+4*ecx]
        cmp edi,0
        je NotLoadPattern

        pushad
        MSetPos edi
        mov eax,Offset LPid
        MRead eax,USMPatternSize
        popad

        Calloc LPSize           ; Allocate USM Pattern Memory
        mov MPattPtr[esi+4*ecx],eax

        pushad
        push eax
        MSetPos edi
        pop eax
        MRead eax,LPSize
        popad

NotLoadPattern:

        inc ecx
        cmp cx,MPatterns[esi]
        jne LoadPatternsLoop	; Pattern Loop

	clc
	ret

USM_LoadPatterns Endp

;͸
;  USM_LoadSamples: Load USM samples and instruments                      
;                                                                         
;

USM_LoadSamples Proc Near
	mov esi,USMH

	cmp MSamples[esi],0
	je NotLoadSamples

	xor ecx,ecx
LoadSamplesLoop:
	mov edi,MSamplPtr[esi+4*ecx]

	cmp edi,0
	je NotLoadSample

        Malloc USSSampleSize
	mov MSamplPtr[esi+4*ecx],eax	;Save the Sample Offset

	pushad
	push eax
	MSetPos edi
	pop eax
	MRead eax,USSSampleSize
	popad

	mov edi,eax

	test SType[edi],SM_Loaded    ; Is sample data in the file ?
	jz NotLoadSample
        and SType[edi],Not SM_Loaded ; Sample data is not in memory
        
	pushad
	MSetPos SPointer[edi]

        call LU_LoadSample      ; Load sample data.
	popad

NotLoadSample:
	inc ecx
	cmp cx,MSamples[esi]
	jne LoadSamplesLoop

NotLoadSamples:


; Loads the instruments structures

        cmp MInstruments[esi],0
	je NotLoadInstruments

        xor ecx,ecx
LoadInstrumentsLoop:
	mov edi,MInstrPtr[esi+4*ecx]

	cmp edi,0
	je NotLoadInstrument

	Calloc USSInstrSize
	mov MInstrPtr[esi+4*ecx],eax    ;Save the Instrument Offset

	pushad
	push eax
	MSetPos edi                     ;Seek file pointer to instrument pos
	pop eax
	MRead eax,USSInstrSize          ;Load the Instrument
	popad

NotLoadInstrument:
	inc ecx
	cmp cx,MInstruments[esi]
	jne LoadInstrumentsLoop

NotLoadInstruments:

	ret
USM_LoadSamples Endp

CODE32 ENDS
;=============================================================================
end
; USMLOAD.INC (c) 1997 FreddyV/Useless