;            ͻ
;                  XMLOAD.ASM       
;                                                               
;                        Useless XM Loader (XM->USM)            
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code starts .................. 06/04/1996       
;               Last update .................. 31/12/1996       
;            ͼ

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32

Yes Equ 0
No  Equ -1

FullLoad Equ Yes	; Yes => Load all (Players,trackers..)
			; No  => Load all needed for the module (Demos,games..)

INCLUDE OS.INC
INCLUDE XMLOAD.INC

INCLUDE LOADUTIL.INC
INCLUDE USS.INC
INCLUDE USM.INC		; Useless Module Structures Definition
INCLUDE USSVAR.INC      ; Istruments and samples definition

INCLUDE MEMORY.INC
INCLUDE UTILS.INC       ; For the writeln macro.

;----------------------------------------------------------------------------

XMH	DD 0
USMH	DD 0

XMOffset DD 0
USMFlags DW 0

;----------------------------------------------------------------------------

PCount DW 0
PTotal DW 0
PPtr   DD 0
PEnd   DD 0
PattSize  DD 0

XMPPtr DD 0

; XM Pattern Header.

XMPHLen DD 0
XMPType DB 0
XMProw  DW 0
XMPsize DW 0

;----------------------------------------------------------------------------

ICount	DW 0
ITotal	DW 0
SCount	DW 0
SNumber DW 0

SfOffset   DD 0
XMIOffset  DD 0
USMIOffset DD 0

; XM Instrument Header

ISize      DD 0			
Insname    DB 22 DUP (0)
IType      DB 0
INbSamples DW 0

; XM Samples Header

XMSLength  DD 0
XMSLoop	   DD 0
XMSLoopLen DD 0
XMSVolume  DB 0
XMSFine	   DB 0	
XMSType    DB 0
XMSPanning DB 0
XMSRelNote DB 0	
XMSRes     DB 0
XMSName    DB 22 DUP (0)

AVTypeConv DB 0,2,4,1

;=============================================================================

;͸
;  XM_LOAD: Load/convert an XM file. (XM->USM)                            
;                                                                         
; Input: ESI file name/path                                               
;                                                                         
; Output: CF Set=> Error                                                  
;         EAX returns the error number                                    
;                                                                         
;         CF Clear                                                        
;         ESI pointer to the USM module                                   
;
XM_LOAD Proc

	MOpen ESI
	jc XMLoadErr
	
	; *** Load the XM Header ***
	
	Calloc USMHeaderLen
	jc XMLoadMemErr
	mov USMH,eax
	
	Malloc XMHeaderLen
	mov XMH,eax
	jc XMLoadMemErr
	
	Mread eax,XMHeaderLen		;Read the XM Header
	jc XMLoadErr
	
	; *** Convert XM Header -> USM Header ***

	mov esi,XMH
	mov edi,USMH

	mov MTracker[edi],M_XM

	If FullLoad eq yes
	mov MId[edi],'MLSU'
	mov MLen[edi],0        ;! To set !
			
	mov ecx,5
	add esi,XMName
	add edi,MName
	cld
	rep movsd		;Convert the Module Name
	
	mov esi,XMH
	mov edi,USMH
	mov ax,XMVersion[esi]
	cmp ax,0104h
	Jb  XMLoadErr
	EndIf

				;Set Panning Table
	push edi
	add edi,MChPan
	mov cx,32/4
	mov eax,80808080h
	rep stosd	
	pop edi

	mov ax,XMFlags[esi]
	and ax,00000000000000001b
	add ax,F_SetPann+F_InstrMode
	mov MFlags[edi],ax
	mov USMFlags,ax
	
	mov ax,XMChannels[esi]
	mov MChannels[edi],ax	
	mov MUS_Channels,ax
	
	mov ax,XMSongLen[esi]
	mov MSongLen[edi],ax
	
	mov ax,XMPatterns[esi]
	mov MPatterns[edi],ax	
	mov PTotal,ax		;Save the Number of patterns
	
	mov ax,XMRestart[esi]
	mov MRestart[edi],ax	
	
	mov ax,XMInstr[esi]
	mov MInstruments[edi],ax
	mov ITotal,ax		;Save the number of instruments
	
	mov ax,XMTempo[esi]
	mov MTempo[edi],al
	
	mov ax,XMBPM[esi]
	mov MBPM[edi],al

	mov eax,XMHSize[esi]
	add eax,XMHSize		;Size from XMHeaderSize value
	mov XMOffset,eax
	MSetPos eax		;Set Filepos to the 1st Pattern
	
	add esi,XMOrder
	add edi,MOrder
	mov cx,256/4
	cld
	rep movsd		

        Free XMH

	call XM_LoadPatterns
	
	call XM_LoadInstruments

	mov esi,USMH		;Returns a pointer to the Module...
	jmp XMLoadEnd	
	
XMLoadMemErr:
	call _MEMORY_ERROR
	
XMLoadErr:
	MCLose		;Close the file
	Writeln 'XMLoad Error'

	stop
	
	stc
	ret
XMNotLoaded:
	stc
	ret
XMLoadEnd:
	MClose		;Close the file
	clc
	ret
XM_LOAD Endp


;͸
;  XM_Loadpatterns: Load/convert XM patterns. (XM->USM)                   
;                                                                         
;

;Warning: PTotal must be >0 

XM_LoadPatterns Proc Near

	mov PCount,0
	
_LoadPatternsLoop:
	
	mov edx,Offset XMPHLen
	MRead edx,9
	
	mov eax,XMPHLen
	add XMOffset,eax
	
	movzx eax,XMProw

        If FullLoad eq Yes
	cmp eax,256	
	ja XM_LoadPatternsErr
	EndIf
	
	cmp XMPSize,0           ;XM Pattern Empty
	je XMPAtternEmpty
		
	movzx eax,XMProw        ; Ligne inutile, mais bon, C pas grave...
	mov bx,MUS_Channels
	mul bx	
	mov bx,5
	mul bx			;rows*Channels*5 => Pattern date size
	
	add eax,USMPatternSize
	
	mov PattSize,eax        ;Total pattern size
	Calloc eax		;Allocate USM Pattern Memory
	mov PPtr,eax

	mov edi,USMH
	movzx edx,PCount
	mov MPattPtr[edi+4*edx],eax	;Save the Pattern Offset

	movzx eax,XMPSize
	Malloc eax		;Allocate the XM patter data buffer
	mov XMPPtr,eax
	
	movzx ecx,XMPSize
	MRead eax,ecx	 	;Load the XM pattern data

	; Convert the pattern XM->USM
	
	mov esi,XMPPtr	
	mov edi,PPtr
	
	mov ax,PCount
	mov Pnumber[edi],ax
	mov ax,XMProw
	mov Prow[edi],ax

        If FullLoad eq yes
	mov PId[edi],'PLSU'
        mov eax,PattSize
	mov Psize[edi],eax
        endif 

        mov PEnd,edi
	add PEnd,eax
	
	add edi,USMPatternSize
	
_Pconvert_loop:
	lodsb			
	test al,10000000b
	jnz _Packed

	cmp al,97
	jne _NoKeyOff1
	mov al,255
_NoKeyOff1:	
	stosb		;write note

	movsd		;move Instr/vol/cmp/param
	jmp _PconvertEnd	
	
_Packed	:
	mov bl,al
	xor eax,eax
	
	test bl,1b
	jz _noNote
	
	lodsb
	cmp al,97
	jne _NoKeyOff2
	mov al,255
_NoKeyOff2:		
_noNote:
	stosb
	shr bl,1
	mov ecx,4
_UnpackLoop	:
	xor eax,eax
	shr bl,1 
	jnc _noData 
	lodsb
_noData:
	stosb
	loop _UnpackLoop
	
_PconvertEnd:

	cmp byte Ptr [edi-2],14    ; Convert Command Exy to Command 36+x
	jne No_ExtendedCommand
	mov al,[edi-1]
	shr al,4
	add al,36
	mov [edi-2],al
	and byte Ptr [edi-1],0Fh
No_ExtendedCommand:	

	cmp edi,PEnd
	jb  _Pconvert_Loop

	Free XMPPtr

XMPatternEmpty:	
	
	movzx eax,XMPsize	; Move in the file
	add XMOffset,eax

	MSetPos XMOffset		
	
	inc PCount
	mov ax,PTotal
	cmp PCount,ax
	jne _LoadPatternsLoop	; Pattern Loop

	clc
	ret

	If FullLoad eq Yes
XM_LoadPatternsErr:

	writeln 'XM Pattern Error.' 
	
	stop	
		
	stc 
	ret
	EndIf

XM_LoadPatterns Endp

;͸
;  XM_LoadInstruments: Load/convert XM instruments. (XM->USM)             
;                                                                         
;

XM_LoadInstruments Proc Near
	mov ICount,0
	mov SNumber,0

	Malloc XMInstrumentSize	
	mov XMIOffset,eax

_LoadInstrumentsLoop:

	MSetPos XMOffset

	;Load First Part
	
	mov edx,Offset ISize
	MRead edx,29
	
	;Allocate Instrument Header
	
	Calloc USSInstrSize
	mov USMIOffset,eax
	
	mov edi,USMH
	movzx edx,ICount
	mov MInstrPtr[edi+4*edx],eax	;Save the Instrument Offset
	
	;Convert XM Instrument -> USM Instrument (First Part)
	
	xor eax,eax
	mov edi,USMIOffset
	mov ax,INbSamples
	mov INbSmp[edi],ax

	If FullLoad eq Yes	
	mov IId[edi],'TSNI'
	mov ILen[edi],USSInstrSize
        add edi,IName
	mov esi,Offset InsName
	mov ecx,22/4
	cld
	rep movsd
	mov edi,USMIOffset
	endif

	mov eax,ISize	
	add XMOffset,eax		;Move file pointer

	cmp INbSamples,0
	je  _XMNoSamples
	
	; Load Second Part

	mov eax,XMIOffset
	Mread eax,XMInstrumentSize      ;Read XM Instrument Header

	mov esi,XMIOffset
	mov eax,XMISSize[esi]		;Sample Header Len
	mov bx,INbSamples
	mul bx				;eax <- samples * Sample Header len
	add eax,XMOffset		;eax <- eax+File Offset
	mov SfOffset,eax		;SfOffset <- Samples Data Start (in file)	
	
	; Convert Second Part
	
	mov esi,XMIOffset		;Samples Number Table
	add edi,ISNumber
	add esi,XMISNumber
	mov ecx,96
	cld
	rep movsb

	mov esi,XMIOffset
	mov edi,USMIOffset

	mov ax,SNumber
	xor ecx,ecx
AddSNumberLoop:
	add ISNumber[edi+ecx],al	
	inc ecx
	cmp ecx,120
	jne AddSNumberLoop
	
	add esi,XMIVEnvelope
	add edi,IVEnvelope
	mov ecx,112/4
	cld
	rep movsd	

        mov edi,USMIOffset
        movzx eax,IVibType[edi]
        and al,3
        mov al,AVTypeConv[eax]
        mov IVibType[edi],al

	add USMIOffset,USSInstrSize	;Memory Offset to first sample Header

	mov SCount,0
_LoadSamplesLoop:		
	
	
	MSetPos XMOffset	 ;Set file Poiner to Sample Header
	add XMOffset,40		
	
	mov edx,Offset XMSLength
	Mread edx,40		 ;Read Sample header

        Calloc USSSampleSize
        mov USMIOffset,eax	
	mov edi,eax              ; Get Sample Header Offset

	mov esi,USMH
	movzx edx,SNumber
	mov MSamplPtr[esi+4*edx],edi	;Save the Sample Offset

	If FullLoad eq Yes		
	mov SId[edi],'LPMS'
	mov SLen[edi],USSSampleSize
	add edi,SName
	mov esi,Offset XMSName
	mov ecx,22/4
	cld
	rep movsd
	mov edi,USMIOffset
	endif	

	;Convert XM Sample -> USM Sample
	
	mov eax,XMSLength	; Convert Length And Loop
	mov SLength[edi],eax
	mov eax,XMSLoop
	mov SLoop[edi],eax
	add eax,XMSLoopLen
	mov SLoopEnd[edi],eax
	
	mov al,XMSVolume
	mov SVolume[edi],al
	mov al,XMSPanning
	mov SPanning[edi],al
	mov al,XMSRelNote
	mov SRelNote[edi],al
	
	xor bl,bl               ; Convert sample type ( 8/16bit, loop... ) 
	mov al,XMSType
	test al,00010000b
	jz _XMS8Bit
	or  bl,SM_16bit		; Set 16 bit Sample
_XMS8bit:			
	and al,00000011b
	cmp al,0
	je _XMSNoLoop		
	or  bl,SM_Loop		; Set sample Loop
	cmp al,1
	je _XMSNoLoop
	or  bl,SM_Bidi		; Set Ping-Pong Loop
_XMSNoLoop:
	or  bl,SM_Delta
	mov SType[edi],bl			

	movsx ax,XMSFine
	movsx eax,ax

	test USMFlags,F_Linear
	jnz NoST3Fine
	imul eax,973
	sar eax,8
	add eax,8363
NoST3Fine:
	mov SFine[edi],ax

	MSetPos SfOffset	; Set file pointer to Sample Start
	mov eax,XMSLength
	add SfOffset,eax

	inc SNumber             ; !!!!! Check if >255 !!!!!

	cmp SLength[edi],0
	je  NotLoadSample
	call LU_LoadSample     ; Load sample data.
NotLoadSample:

	; ** Sample load end, load next sample **
	
	inc SCount 
	mov ax,INbSamples
	cmp SCount,ax
	jne _LoadSamplesLoop

	mov eax,SfOffset	
	mov XMOffset,eax	; File Offset <- Sample Data Offset

_XMNoSamples:		

	inc ICount
	mov ax,Itotal
	cmp ICount,ax
	jne _LoadInstrumentsLoop

	free XMIOffset

        mov esi,USMH
        mov ax,SNumber
        mov MSamples[esi],ax

	ret
XM_LoadInstruments Endp

CODE32 ENDS
;=============================================================================
end
; XMLOAD.ASM (c) 1997 FreddyV/Useless